<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBENEFICIAIRE ArrayType
 * @subpackage Arrays
 */
class ArrayOfBENEFICIAIRE extends AbstractStructArrayBase
{
    /**
     * The BENEFICIAIRE
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BENEFICIAIRE[]
     */
    public $BENEFICIAIRE;
    /**
     * Constructor method for ArrayOfBENEFICIAIRE
     * @uses ArrayOfBENEFICIAIRE::setBENEFICIAIRE()
     * @param \StructType\BENEFICIAIRE[] $bENEFICIAIRE
     */
    public function __construct(array $bENEFICIAIRE = array())
    {
        $this
            ->setBENEFICIAIRE($bENEFICIAIRE);
    }
    /**
     * Get BENEFICIAIRE value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BENEFICIAIRE[]|null
     */
    public function getBENEFICIAIRE()
    {
        return isset($this->BENEFICIAIRE) ? $this->BENEFICIAIRE : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBENEFICIAIRE method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBENEFICIAIRE method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBENEFICIAIREForArrayConstraintsFromSetBENEFICIAIRE(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBENEFICIAIREBENEFICIAIREItem) {
            // validation for constraint: itemType
            if (!$arrayOfBENEFICIAIREBENEFICIAIREItem instanceof \StructType\BENEFICIAIRE) {
                $invalidValues[] = is_object($arrayOfBENEFICIAIREBENEFICIAIREItem) ? get_class($arrayOfBENEFICIAIREBENEFICIAIREItem) : sprintf('%s(%s)', gettype($arrayOfBENEFICIAIREBENEFICIAIREItem), var_export($arrayOfBENEFICIAIREBENEFICIAIREItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BENEFICIAIRE property can only contain items of type \StructType\BENEFICIAIRE, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BENEFICIAIRE value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\BENEFICIAIRE[] $bENEFICIAIRE
     * @return \ArrayType\ArrayOfBENEFICIAIRE
     */
    public function setBENEFICIAIRE(array $bENEFICIAIRE = array())
    {
        // validation for constraint: array
        if ('' !== ($bENEFICIAIREArrayErrorMessage = self::validateBENEFICIAIREForArrayConstraintsFromSetBENEFICIAIRE($bENEFICIAIRE))) {
            throw new \InvalidArgumentException($bENEFICIAIREArrayErrorMessage, __LINE__);
        }
        if (is_null($bENEFICIAIRE) || (is_array($bENEFICIAIRE) && empty($bENEFICIAIRE))) {
            unset($this->BENEFICIAIRE);
        } else {
            $this->BENEFICIAIRE = $bENEFICIAIRE;
        }
        return $this;
    }
    /**
     * Add item to BENEFICIAIRE value
     * @throws \InvalidArgumentException
     * @param \StructType\BENEFICIAIRE $item
     * @return \ArrayType\ArrayOfBENEFICIAIRE
     */
    public function addToBENEFICIAIRE(\StructType\BENEFICIAIRE $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BENEFICIAIRE) {
            throw new \InvalidArgumentException(sprintf('The BENEFICIAIRE property can only contain items of type \StructType\BENEFICIAIRE, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BENEFICIAIRE[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\BENEFICIAIRE|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\BENEFICIAIRE|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\BENEFICIAIRE|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\BENEFICIAIRE|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\BENEFICIAIRE|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BENEFICIAIRE
     */
    public function getAttributeName()
    {
        return 'BENEFICIAIRE';
    }
}
